/* 2003/1/1
 *
 * linkedlist.c - uNhXgv
 *
 * Presented by YUTAKA
 */
#include <stdio.h>
#include <stdlib.h>

/* R[h */
typedef struct record {
	int data;                 /* f[^ */
	char name;
	struct record *next;      /* ̃R[hւ̃|C^ */
} record_t;

record_t *head;   /* wbh */


/* Xg̕\ */
void show_record(void)
{
	record_t *ptr;

	ptr = head;
	while (ptr != NULL) {
		printf("(%c %d)->", ptr->name, ptr->data);
		ptr = ptr->next;
	}
	printf("NULL\n");
}

/* VR[h̃AP[g */
record_t *alloc_record(void)
{
	record_t *ptr;

	ptr = (record_t *)malloc(sizeof(record_t));
	if (ptr == NULL) {
		printf("܂\n");
		exit(1);
	}

	return (ptr);
}

/* NhXg̍폜 */
void delete(char name)
{
	record_t *ptr, *prev;

	prev = ptr = head;
	/* 폜ӏT */
	while (ptr != NULL) {
		if (ptr->name == name)
			break;

		prev = ptr;   /* 1ÕR[hoĂ */
		ptr = ptr->next;
	}
	if (ptr == NULL) {
		printf("폜ӏ܂ (%c)\n", name);
		return;
	}

	/* |C^̂Ȃ */
	if (ptr == head) {  /* 擪R[h̏ꍇ */
		head = ptr->next;
	} else {
		prev->next = ptr->next;
	}

	/* vȂȂR[h͖YꂸɉĂ */
	free(ptr);
}


/* NhXgւ̒ǉ */
void insert(int data, char name)
{
	record_t *ptr, *newptr;

	ptr = head;
	/* }ӏT */
	while (ptr != NULL) {
		if (ptr->name == name)
			break;
		ptr = ptr->next;
	}
	if (ptr == NULL) {
		printf("}ӏ܂ (%c)\n", name);
		return;
	}

	newptr = alloc_record();
	newptr->data = data;
	newptr->name = name;
	
	/* |C^̂Ȃ */
	newptr->next = ptr->next;
	ptr->next = newptr;
}

/* Xg̏ */
void init(void)
{
	int data[] = {16, 8, 5, 1, 0, 13, 22, -1};
	int i;
	record_t *ptr;

	head = NULL;
	for (i = 0 ; data[i] != -1 ; i++) {
		ptr = alloc_record();
		ptr->data = data[i];
		ptr->name = (char)('A' + i);
		ptr->next = head;
		head = ptr;
	}

}

/* C֐ */
int main(void)
{
	printf("Xg̏ԁF\n");
	init();
	show_record();
	printf("\n");

	printf("XgZ, C, G̒ǉ݂܂\n");
	insert(2003, 'Z');
	show_record();
	insert(2003, 'C');
	show_record();
	insert(2003, 'G');
	show_record();
	printf("\n");

	printf("XgZ, A, F̍폜݂܂\n");
	delete('Z');
	show_record();
	delete('A');
	show_record();
	delete('F');
	show_record();

	return 0;
}


