/*
 * cal.c - uJ_[v
 *
 * Presented by YUTAKA
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

/* #define NDEBUG */
#include <assert.h>


/* yearNmonth1̗j߂(Zelleř) */
int get_day_of_week(int year, int month) 
{
	int week;

	if (month < 3) {
		year--;
		month += 12;
	}
	week = (year + year / 4 - year / 100 + year / 400 +
		((13 * month + 8) / 5) + 1) % 7;

	return (week);
}


/* 邤N̔ */
int is_leap_year(int year)
{
	return ((year % 4 == 0 && year % 100) ? 1 :
		(year % 400 == 0 ? 1 : 0)
		);
}

/* J_[̕\ */
void show_calendar(int year, int month)
{
	int days[12 + 1] = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
	int week, i;

	/* AT[V`FbN */
	assert(month >= 1 && month <= 12);

	if (is_leap_year(year)) {
		/* 邤NȂ2̓𑝂₷ */
		days[2]++;
	}

	/* ̗jvZ */
	week = get_day_of_week(year, month);

	/* Wo͂֕\ */
	printf("%d/%d\n", year, month);
	printf("Sun Mon Tue Wed Thu Fri Sat\n");

	/* 1ڂ̗jɍ킹ċ󔒂o͂Ă */
	if (week > 0) {
		printf("%*s", week * 4, " ");
	}

	for (i = 1 ; i <= days[month] ; i++) {
		/* ɂ̕\ */
		printf("%-3d ", i);

		week++;
		if (week == 7) {  /* 1Tԕ̕\I */
			week = 0;
			printf("\n");
		}
	}
	printf("\n");
}


/* C֐ */
int main(int argc, char **argv)
{
	int month, year;
	time_t ct;
	struct tm *newtime;

	month = year = 0;

	/* R}hC */
	if (argc > 1) {
		/* ICwv\ďI */
		if (strcmp(argv[1], "-h") == 0) {
			printf("Usage: cal [[] N]\n");
			exit(1);
		}

		month = atoi(argv[1]);

		if (argc > 2) {
			year = atoi(argv[2]);
		}
	}

	/* N̎w肪Ȃ΁Cݎ擾 */
	ct = time(NULL);
	newtime = localtime(&ct);
	if (month == 0) {
		month = newtime->tm_mon + 1;
	}
	if (year == 0) {
		year = newtime->tm_year + 1900;
	}

	show_calendar(year, month);

	return 0;
}

