/* 2002/12/22
 *
 * calc.c - ut|[hdv
 *
 * Presented by YUTAKA
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <assert.h>

/*
 * }N`
 */
#define MAX_LINE_SIZE 512

/*
 * O[oϐ
 */
int gNumMapTable[256];   /*  <-> lΉ\ */



/* t|[h(buf)vZ */
double calculate(char *buf)
{
	double ans[MAX_LINE_SIZE], tmp;
	char *p = buf;
	int sp = 0;
	
	while (*p) {
		/* At@xbg͐l֖߂ */
		if ( *p >= 'a' && *p <= 'z' ) {
			ans[sp++] = gNumMapTable[*p];

		} else {
			/* X^bN2̐loZs */
			switch (*p) {
 			case '+':
				tmp = ans[sp - 2] + ans[sp - 1];
 				break;
 			case '-':
				tmp = ans[sp - 2] - ans[sp - 1];
 				break;
 			case '*':
				tmp = ans[sp - 2] * ans[sp - 1];
 				break;
 			case '/':
				tmp = ans[sp - 2] / ans[sp - 1];
 				break;
			default:
				printf("sȉZqł (%c)\n", *p);
				exit(1);
				break;
 			}

			/* ZʂX^bN֐ς */
 			ans[sp - 2] = tmp;
 			sp--;
		}
		p++;
	}

	return (ans[0]);
}


/* (buf)t|[hL@(polish)֕ϊ 
 *
 * )
 * a+b*c-d    abc*+d-
 *
 */
void conv_polish(char *buf, char *polish)
{
	char *p = buf;
	char stack[256]; /* X^bN */
	int pri[256];    /* Zq̗Dxe[u */
	int i, sp1, sp2;

	/* Dx̐ݒ */
	for (i = 0 ; i < 256 ; i++) {
		pri[i] = 3;
	}
	pri['+'] = pri['-'] = 1;
	pri['*'] = pri['/'] = 2;
	pri[0] = -1;

	
	stack[0] = 0; 
	sp1 = sp2 = 0;
	/* 1 */
	while (*p) {
		/* X^bNɂ鉉Zq̂قDxԁC
		 * X^bNoB
		 */
		while (pri[*p] <= pri[ stack[sp1] ]) {
			polish[sp2++] = stack[sp1--];
		}

		/* ZqX^bN֐ς */
		assert(sp1 < sizeof(stack));
		stack[++sp1] = *p++;
	}

	/* X^bNɎcĂ鉉Zqo */
	for (i = sp1 ; i > 0 ; i--) {
		polish[sp2++] = stack[i];
	}

	/* I[Zbg */
	polish[sp2] = 0;
}


/* (buf)(pol)֕ϊ 
 *
 * )
 * 12+3*5    a+b*c
 *
 *             gNumMapTable['a'] = 12
 *             gNumMapTable['b'] = 3
 *             gNumMapTable['c'] = 5
 */
void conv_char(char *buf, char *pol)
{
	char *p = buf;
	long n;
	int i;
	
	i = 0;
	while (*p) {
		if (!isdigit(*p)) {
			*pol++ = *p;
			p++;
			continue;
		}
		n = 0;
		while (isdigit(*p)) {
			n = 10 * n + (*p - '0');
			p++;
		}

		/* At@xbg26𒴂G[Ƃidlj*/
		assert(i < 26);

		gNumMapTable['a'+i] = n;
		*pol++ = (char)('a' + i);
		i++;
	}
	*pol = 0;
}


/* C֐ */
int main(void)
{
	char buf[MAX_LINE_SIZE];
	char conv_buf[MAX_LINE_SIZE];
	char polish_buf[MAX_LINE_SIZE];
	int len;
	double ans;

	/* W͂sǂݍ */
	while (fgets(buf, sizeof(buf), stdin) != NULL) {
		len = strlen(buf);
		/* sɉsR[h΍폜 */
		if (buf[len - 1] == '\n') {
			buf[len - 1] = 0;
		}
		if (buf[0] == '\0')
			continue;

		conv_char(buf, conv_buf);
		/* printf("%s -> %s\n", buf, conv_buf); */

		conv_polish(conv_buf, polish_buf);
		/* printf("%s -> %s\n", conv_buf, polish_buf); */

		ans = calculate(polish_buf);
		printf("%s\n%.2f\n", buf, ans);
	}

	return 0;
}


