/* 2002/12/25
 *
 * dice.c                    
 * [WJ}]
 *
 * Copyright (C)2002 YUTAKA
 * All rights reserved.
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <assert.h>


/* ʒu\}N */
#define POS(x,y) ((x) + (y)*3)
/* ͈͊OANZX`FbN}N */
#define VALID(x,y) ((x)>=0 && (x)<=2 && (y)>=0 && (y)<=5)

enum {
	NORTH, WEST, SOUTH, EAST
};

int board[3 * 6];				/* TCRWJ̈ */
int use[7];						/* TCReʂ̎gpς݃`FbN */
int count;						/* ̐ */

#define RECMAX 200
int rec[RECMAX][3 * 6];			/* ̋L^ */

/* 
 TCR̖ʔԍ͎̂ƂƂB

          4
        /
      .......
     /  6   /|
    /      /5| 
3-  |''''''| /
    |  2   |/
    ''''''''
        |
        1

 */

/* WJ}f[^ dir[ʔԍ][4]][] */
int dir[7][4][4] = {
	{
	 {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0},
	 },
	{
	 {4, 3, 2, 5}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0},	/* 1 */
	 },
	{
	 {1, 3, 6, 5}, {3, 6, 5, 1}, {6, 5, 1, 3}, {5, 1, 3, 6},	/* 2 */
	 },
	{
	 {4, 6, 2, 1}, {6, 2, 1, 4}, {2, 1, 4, 6}, {1, 4, 6, 2},	/* 3 */
	 },
	{
	 {6, 3, 1, 5}, {3, 1, 5, 6}, {1, 5, 6, 3}, {5, 6, 3, 1},	/* 4 */
	 },
	{
	 {4, 1, 2, 6}, {1, 2, 6, 4}, {2, 6, 4, 1}, {6, 4, 1, 2},	/* 5 */
	 },
	{
	 {4, 5, 2, 3}, {5, 2, 3, 4}, {2, 3, 4, 5}, {3, 4, 5, 2},	/* 6 */
	 },
};


/* WJ}rWAɕ\ */
void disp(int *board)
{
	int x, y;

	for (y = 0; y < 6; y++) {
		for (x = 0; x < 3; x++) {
			printf("%s", board[POS(x, y)] == '*' ? "" : "  ");
		}
		printf("\n");
	}
}

/* ̕\ */
void finish(void)
{
	int i;

	for (i = 0; i < count; i++) {
		printf("No.%d\n", i + 1);
		disp(rec[i]);
	}
}

/* ̏d𒲂דo^ */
void record(void)
{
	int i, j, x, y, lasty, ly;
	int tmp[3 * 6];

	/* WJ}Lɒu */
	for (i = 0; i < 3 * 6; i++) {
		tmp[i] = board[i] ? '*' : ' ';
	}
	/* K */
	if (tmp[0] == ' ' && tmp[1] == ' ' && tmp[2] == ' ') {
		for (i = 3; i < 3 * 6; i++)
			tmp[i - 3] = tmp[i];
		tmp[15] = tmp[16] = tmp[17] = ' ';
	}

	lasty = 0;
	for (y = 5; y >= 0; y--)
		for (x = 0; x < 3; x++)
			if (tmp[POS(x, y)] == '*') {
				lasty = y;
				goto SKIP;
			}
  SKIP:;

	/* dȂׂ */
	for (i = 0; i < count; i++) {
		/* ܂`ǂ */
		for (j = 0; j < 3 * 6; j++)
			if (rec[i][j] != tmp[j])
				break;
		if (j == 3 * 6)
			break;

		/* EΏ̂œǂ */
		for (y = 0; y < 6; y++)
			for (x = 0; x < 3; x++)
				if (rec[i][POS(x, y)] != tmp[POS(2 - x, y)])
					goto SKIP2;
		break;
	  SKIP2:;

		/* ]œǂ */
		ly = 0;
		for (y = 5; y >= 0; y--)
			for (x = 0; x < 3; x++)
				if (rec[i][POS(x, y)] == '*') {
					ly = y;
					goto SKIP3;
				}
	  SKIP3:;
		if (lasty == ly) {
			for (y = 0; y <= lasty; y++)
				for (x = 0; x < 3; x++)
					if (rec[i][POS(x, y)] != tmp[POS(2 - x, lasty - y)])
						goto SKIP4;
			break;
		  SKIP4:;
		}
	}

	assert(count < RECMAX);

	/* VƂēo^ */
	if (i == count) {
		for (j = 0; j < 3 * 6; j++)
			rec[count][j] = tmp[j];
		count++;
	}
}

/* (x,y)ɂpiece𒆐SɂāAdirectionɒuʂ肷B*/
int get_num(int piece, int x, int y, int direction)
{
	int i;

	if (piece == 1)
		return (dir[piece][0][direction]);

	/* ɖʂ邩ׂ */
	if (VALID(x, y + 1) && board[POS(x, y + 1)]) {
		for (i = 0; i < 4; i++) {
			if (dir[piece][i][SOUTH] == board[POS(x, y + 1)])
				break;
		}
		return (dir[piece][i][direction]);
	}

	/* kɖʂ邩ׂ */
	if (VALID(x, y - 1) && board[POS(x, y - 1)]) {
		for (i = 0; i < 4; i++) {
			if (dir[piece][i][NORTH] == board[POS(x, y - 1)])
				break;
		}
		return (dir[piece][i][direction]);
	}

	/* ɖʂ邩ׂ */
	if (VALID(x - 1, y) && board[POS(x - 1, y)]) {
		for (i = 0; i < 4; i++) {
			if (dir[piece][i][WEST] == board[POS(x - 1, y)])
				break;
		}
		return (dir[piece][i][direction]);
	}

	/* ɖʂ邩ׂ */
	if (VALID(x + 1, y) && board[POS(x + 1, y)]) {
		for (i = 0; i < 4; i++) {
			if (dir[piece][i][EAST] == board[POS(x + 1, y)])
				break;
		}
		return (dir[piece][i][direction]);
	}

	printf("Program miss\n");	/* ɗ邱Ƃ͂Ȃ͂ */
	exit(1);
}

/* TCR1ʂWJĂ */
void sub(int n)
{
	int x, y, num, piece;

	/* 5ʓWJł */
	if (n >= 5) {
		record();
		return;
	}

	for (y = 0; y < 6; y++) {
		for (x = 0; x < 3; x++) {
			/* WJς݂̖ʂT */
			piece = board[POS(x, y)];
			if (piece == 0)
				continue;

			/* kɒu邩ׂ */
			if (VALID(x, y - 1) && board[POS(x, y - 1)] == 0) {
				num = get_num(piece, x, y, NORTH);
				if (use[num] == 0) {
					use[num] = 1;
					board[POS(x, y - 1)] = num;
					sub(n + 1);
					board[POS(x, y - 1)] = 0;
					use[num] = 0;
				}
			}

			/* ɒu邩ׂ */
			if (VALID(x - 1, y) && board[POS(x - 1, y)] == 0) {
				num = get_num(piece, x, y, WEST);
				if (use[num] == 0) {
					use[num] = 1;
					board[POS(x - 1, y)] = num;
					sub(n + 1);
					board[POS(x - 1, y)] = 0;
					use[num] = 0;
				}
			}

			/* ɒu邩ׂ */
			if (VALID(x, y + 1) && board[POS(x, y + 1)] == 0) {
				num = get_num(piece, x, y, SOUTH);
				if (use[num] == 0) {
					use[num] = 1;
					board[POS(x, y + 1)] = num;
					sub(n + 1);
					board[POS(x, y + 1)] = 0;
					use[num] = 0;
				}
			}

			/* ɒu邩ׂ */
			if (VALID(x + 1, y) && board[POS(x + 1, y)] == 0) {
				num = get_num(piece, x, y, EAST);
				if (use[num] == 0) {
					use[num] = 1;
					board[POS(x + 1, y)] = num;
					sub(n + 1);
					board[POS(x + 1, y)] = 0;
					use[num] = 0;
				}
			}
		}
	}
}

/*  */
void init(void)
{
	memset(board, 0, sizeof(board));
	board[POS(0, 1)] = 1;		/* 1ʂ͌ߑł */
	use[1] = 1;
}

/* C֐ */
int main(void)
{
	clock_t t = clock();

	init();
	sub(0);
	finish();

	printf("time %.2f\n", (double)((clock() - t) / CLOCKS_PER_SEC));
	return 0;
}


